import random
import urllib.request
from zeep import Client

LOGIN = "Administrator"
PWD = "wf"
DEFINITION_NAME = "complete_task_sample"
TASK_NAME = "Ввести ответ"
VARIABLE_REQUEST_NAME = "Вопрос"
VARIABLE_RESPONSE_NAME = "Ответ"

def get_response(varable_value):
    return random.choice([True, False])

def create_batch_presentation(presentation_type, page_number, page_size, variables, filters, sortings):
  request = task_api.get_type('{http://impl.service.wfe.runa.ru/}wfBatchPresentation')()
  request.classPresentationType = presentation_type
  request.pageNumber = page_number
  request.pageSize = page_size
  request.variables = variables
  request.filters = filters
  request.sortings = sortings
  return request

def create_filter(name, value, exclusive):
  filter = execution_api.get_type("ns0:filter")()
  filter.name = name
  filter.value = value
  filter.exclusive = exclusive
  return filter

wfe_version = urllib.request.urlopen("http://localhost:8080/wfe/version").read().decode('utf-8')

BASE_URL = "http://localhost:8080/wfe-service-" + wfe_version
AUTHENTICATION_API_URL = BASE_URL + "/AuthenticationWebService/AuthenticationAPI?wsdl"
TASK_API_URL = BASE_URL + "/TaskWebService/TaskAPI?wsdl"
EXECUTION_API_URL = BASE_URL + "/ExecutionWebService/ExecutionAPI?wsdl"

authentication = Client(AUTHENTICATION_API_URL)
user = authentication.service.authenticateByLoginPassword(LOGIN, PWD)
task_api = Client(TASK_API_URL)
execution_api = Client(EXECUTION_API_URL)

for task in task_api.service.getMyTasks(
    user, create_batch_presentation("TASK", 1, 100, [VARIABLE_REQUEST_NAME],
        [create_filter("definitionName", DEFINITION_NAME, False), create_filter("name", TASK_NAME, False)], [])):
    if task.variables:
        print("ID экземпляра БП", DEFINITION_NAME, "-", task.processId)
        print("Задание -", task.name)
        variable_request = task.variables[0]
        response_value = get_response(variable_request.value)
        print("Переменные:")
        print("    ", VARIABLE_REQUEST_NAME, "-", variable_request.value)
        print("    ", VARIABLE_RESPONSE_NAME, "-", response_value)
        variable_response = execution_api.get_type('{http://impl.service.wfe.runa.ru/}variable')()
        variable_response.name = VARIABLE_RESPONSE_NAME
        variable_response.value = format(response_value).lower()
        task_api.service.completeTaskWS(user, task.id, [variable_response], task.owner.id)
        print("Выполнено\n")


